// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from OutletGroup.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface OutletGroup_1_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup:1.0.1", null);

  public static final int ERR_INVALID_ARGUMENT = 1;

  static public class Sensors implements Cloneable {
    public Sensors() {
      this.activePower = null;
      this.activeEnergy = null;
    }

    public Object clone() {
      Sensors copy = new Sensors();

      copy.activePower = this.activePower;
      copy.activeEnergy = this.activeEnergy;

      return copy;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_3 activePower;
    public com.raritan.idl.sensors.AccumulatingNumericSensor_2_0_3 activeEnergy;
  }

  static public class Settings implements Cloneable {
    public Settings() {
      this.name = new String();
      this.members = new java.util.ArrayList<com.raritan.idl.pdumodel.Outlet_2_1_5>();
    }

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;
      copy.members = new java.util.ArrayList<com.raritan.idl.pdumodel.Outlet_2_1_5>(this.members);

      return copy;
    }

    public String name;
    public java.util.List<com.raritan.idl.pdumodel.Outlet_2_1_5> members;
  }

  static public class MetaData implements Cloneable {
    public MetaData() {
      this.groupId = new Integer(0);
      this.uniqueId = new Integer(0);
    }

    public Object clone() {
      MetaData copy = new MetaData();

      copy.groupId = this.groupId;
      copy.uniqueId = this.uniqueId;

      return copy;
    }

    public int groupId;
    public int uniqueId;
  }

  public class SensorsChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup_1_0_1.SensorsChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.OutletGroup_1_0_1.Sensors oldSensors;
    public com.raritan.idl.pdumodel.OutletGroup_1_0_1.Sensors newSensors;
  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup_1_0_1.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.OutletGroup_1_0_1.Settings oldSettings;
    public com.raritan.idl.pdumodel.OutletGroup_1_0_1.Settings newSettings;
  }

  public class PowerControlEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup_1_0_1.PowerControlEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Outlet_2_1_5.PowerState state;
    public boolean cycle;
  }

  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.OutletGroup_1_0_1.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.OutletGroup_1_0_1.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.OutletGroup_1_0_1.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.OutletGroup_1_0_1.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.OutletGroup_1_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.OutletGroup_1_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetAllOutletPowerStatesResult {
    public int _ret_;
  }

  SetAllOutletPowerStatesResult setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_2_1_5.PowerState pstate) throws Exception;

  AsyncRequest setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_2_1_5.PowerState pstate, AsyncRpcResponse<SetAllOutletPowerStatesResult> rsp);

  AsyncRequest setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_2_1_5.PowerState pstate, AsyncRpcResponse<SetAllOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);


  public class CycleAllOutletPowerStatesResult {
    public int _ret_;
  }

  CycleAllOutletPowerStatesResult cycleAllOutletPowerStates() throws Exception;

  AsyncRequest cycleAllOutletPowerStates(AsyncRpcResponse<CycleAllOutletPowerStatesResult> rsp);

  AsyncRequest cycleAllOutletPowerStates(AsyncRpcResponse<CycleAllOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);

}
