// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from PowerMeter.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface PowerMeter {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.PowerMeter:1.0.0", null);

  public static final int ERR_INVALID_PARAM = 1;

  public static final int ERR_MODBUS_UNIT_IN_USE = 2;

  public enum Type {
    ONE_PHASE,
    SPLIT_PHASE,
    THREE_PHASE;
  }

  static public class Config implements Cloneable {
    public Config() {
      this.powerMeterId = new Integer(0);
      this.type = com.raritan.idl.pdumodel.PowerMeter.Type.values()[0];
    }

    public Object clone() {
      Config copy = new Config();

      copy.powerMeterId = this.powerMeterId;
      copy.type = this.type;

      return copy;
    }

    public int powerMeterId;
    public com.raritan.idl.pdumodel.PowerMeter.Type type;
  }

  public class GetConfigResult {
    public com.raritan.idl.pdumodel.PowerMeter.Config _ret_;
  }

  GetConfigResult getConfig() throws Exception;

  AsyncRequest getConfig(AsyncRpcResponse<GetConfigResult> rsp);

  AsyncRequest getConfig(AsyncRpcResponse<GetConfigResult> rsp, RpcCtrl rpcCtrl);


  static public class Sensors implements Cloneable {
    public Sensors() {
      this.voltage = null;
      this.lineFrequency = null;
      this.current = null;
      this.activePower = null;
      this.reactivePower = null;
      this.apparentPower = null;
      this.powerFactor = null;
      this.phaseAngle = null;
      this.displacementPowerFactor = null;
      this.activeEnergy = null;
      this.unbalancedCurrent = null;
      this.powerQuality = null;
    }

    public Object clone() {
      Sensors copy = new Sensors();

      copy.voltage = this.voltage;
      copy.lineFrequency = this.lineFrequency;
      copy.current = this.current;
      copy.activePower = this.activePower;
      copy.reactivePower = this.reactivePower;
      copy.apparentPower = this.apparentPower;
      copy.powerFactor = this.powerFactor;
      copy.phaseAngle = this.phaseAngle;
      copy.displacementPowerFactor = this.displacementPowerFactor;
      copy.activeEnergy = this.activeEnergy;
      copy.unbalancedCurrent = this.unbalancedCurrent;
      copy.powerQuality = this.powerQuality;

      return copy;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_1 voltage;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 lineFrequency;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 current;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 activePower;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 reactivePower;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 apparentPower;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 powerFactor;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 phaseAngle;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 displacementPowerFactor;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 activeEnergy;
    public com.raritan.idl.sensors.NumericSensor_4_0_1 unbalancedCurrent;
    public com.raritan.idl.sensors.StateSensor_4_0_1 powerQuality;
  }

  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.PowerMeter.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetPolesResult {
    public java.util.List<com.raritan.idl.pdumodel.Pole_4_0_0> _ret_;
  }

  GetPolesResult getPoles() throws Exception;

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp);

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp, RpcCtrl rpcCtrl);


  public class GetControllersResult {
    public java.util.List<com.raritan.idl.pdumodel.Controller_3_0_0> _ret_;
  }

  GetControllersResult getControllers() throws Exception;

  AsyncRequest getControllers(AsyncRpcResponse<GetControllersResult> rsp);

  AsyncRequest getControllers(AsyncRpcResponse<GetControllersResult> rsp, RpcCtrl rpcCtrl);


  static public class Settings implements Cloneable {
    public Settings() {
      this.name = new String();
      this.currentRating = new Integer(0);
      this.phaseCtRating = new Integer(0);
      this.neutralCtRating = new Integer(0);
      this.earthCtRating = new Integer(0);
      this.modbusUnitAddress = new Integer(0);
    }

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;
      copy.currentRating = this.currentRating;
      copy.phaseCtRating = this.phaseCtRating;
      copy.neutralCtRating = this.neutralCtRating;
      copy.earthCtRating = this.earthCtRating;
      copy.modbusUnitAddress = this.modbusUnitAddress;

      return copy;
    }

    public String name;
    public int currentRating;
    public int phaseCtRating;
    public int neutralCtRating;
    public int earthCtRating;
    public int modbusUnitAddress;
  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.PowerMeter.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.PowerMeter.Settings oldSettings;
    public com.raritan.idl.pdumodel.PowerMeter.Settings newSettings;
  }

  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.PowerMeter.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.PowerMeter.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.PowerMeter.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.PowerMeter.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

}
