// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from SensorHub.idl.

package com.raritan.idl.peripheral;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface SensorHub {
  static public final TypeInfo typeInfo = new TypeInfo("peripheral.SensorHub:1.0.0", null);

  public enum UpstreamType {
    BUILTIN,
    ENV_HUB,
    REMOTE_HUB;
  }

  static public class HubPortInfo implements Cloneable {
    public HubPortInfo() {
      this.hubPort = new String();
      this.fuse = null;
    }

    public Object clone() {
      HubPortInfo copy = new HubPortInfo();

      copy.hubPort = this.hubPort;
      copy.fuse = this.fuse;

      return copy;
    }

    public String hubPort;
    public com.raritan.idl.portsmodel.PortFuse fuse;
  }

  static public class DeviceInfo implements Cloneable {
    public DeviceInfo() {
      this.serial = new String();
      this.model = new String();
      this.upstreamType = com.raritan.idl.peripheral.SensorHub.UpstreamType.values()[0];
      this.position = new com.raritan.idl.peripheral.PosElement_2_0_0();
      this.protocolVersion = new Integer(0);
      this.bootVersion = new Integer(0);
      this.appVersion = new Integer(0);
      this.hubPortInfos = new java.util.ArrayList<com.raritan.idl.peripheral.SensorHub.HubPortInfo>();
    }

    public Object clone() {
      DeviceInfo copy = new DeviceInfo();

      copy.serial = this.serial;
      copy.model = this.model;
      copy.upstreamType = this.upstreamType;
      Object positionCopy = this.position.clone();
      copy.position = (com.raritan.idl.peripheral.PosElement_2_0_0) positionCopy;
      copy.protocolVersion = this.protocolVersion;
      copy.bootVersion = this.bootVersion;
      copy.appVersion = this.appVersion;
      copy.hubPortInfos = new java.util.ArrayList<com.raritan.idl.peripheral.SensorHub.HubPortInfo>(this.hubPortInfos);

      return copy;
    }

    public String serial;
    public String model;
    public com.raritan.idl.peripheral.SensorHub.UpstreamType upstreamType;
    public com.raritan.idl.peripheral.PosElement_2_0_0 position;
    public int protocolVersion;
    public int bootVersion;
    public int appVersion;
    public java.util.List<com.raritan.idl.peripheral.SensorHub.HubPortInfo> hubPortInfos;
  }

  public class GetDeviceInfoResult {
    public com.raritan.idl.peripheral.SensorHub.DeviceInfo _ret_;
  }

  GetDeviceInfoResult getDeviceInfo() throws Exception;

  AsyncRequest getDeviceInfo(AsyncRpcResponse<GetDeviceInfoResult> rsp);

  AsyncRequest getDeviceInfo(AsyncRpcResponse<GetDeviceInfoResult> rsp, RpcCtrl rpcCtrl);


  public class GetPackageInfoResult {
    public com.raritan.idl.peripheral.PackageInfo_3_0_0 _ret_;
  }

  GetPackageInfoResult getPackageInfo() throws Exception;

  AsyncRequest getPackageInfo(AsyncRpcResponse<GetPackageInfoResult> rsp);

  AsyncRequest getPackageInfo(AsyncRpcResponse<GetPackageInfoResult> rsp, RpcCtrl rpcCtrl);

}
