// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Sensor.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Sensor_3_0_0 {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.Sensor:3.0.0", null);

  public static final int ERR_NOT_SUPPORTED = 1;

  public enum Events {
    EVT_KEY_TYPESPEC_CHANGED;
  }

  public enum ReadingType {
    NUMERIC,
    DISCRETE_ON_OFF,
    DISCRETE_MULTI;
  }

  public enum OnOffState {
    OFF,
    ON;
  }

  public enum Type {
    UNSPECIFIED,
    VOLTAGE,
    CURRENT,
    UNBALANCE_CURRENT,
    POWER,
    POWER_FACTOR,
    ENERGY,
    FREQUENCY,
    TEMPERATURE,
    HUMIDITY,
    AIR_FLOW,
    AIR_PRESSURE,
    CONTACT_CLOSURE,
    ON_OFF_SENSOR,
    TRIP_SENSOR,
    VIBRATION,
    WATER_LEAK,
    SMOKE_DETECTOR,
    TOTAL_HARMONIC_DISTORTION,
    MASS,
    ELECTRICAL_RESISTANCE,
    FLUX,
    LUMINOUS_INTENSITY,
    ACCELERATION,
    MAGNETIC_FLUX_DENSITY,
    ELECTRIC_FIELD_STRENGTH,
    MAGNETIC_FIELD_STRENGTH,
    ANGLE,
    SELECTION,
    FAULT_STATE,
    POWER_QUALITY,
    ROTATIONAL_SPEED,
    LUMINOUS_ENERGY,
    LUMINOUS_FLUX,
    ILLUMINANCE,
    LUMINOUS_EMITTANCE;
  }

  public enum Unit {
    NONE,
    VOLT,
    AMPERE,
    WATT,
    VOLT_AMP,
    WATT_HOUR,
    VOLT_AMP_HOUR,
    DEGREE_CELSIUS,
    HZ,
    PERCENT,
    METER_PER_SEC,
    PASCAL,
    G,
    RPM,
    METER,
    HOUR,
    MINUTE,
    SECOND,
    VOLT_AMP_REACTIVE,
    VOLT_AMP_REACTIVE_HOUR,
    GRAM,
    OHM,
    LITERS_PER_HOUR,
    CANDELA,
    METER_PER_SQARE_SEC,
    TESLA,
    VOLT_PER_METER,
    VOLT_PER_AMPERE,
    DEGREE,
    DEGREE_FAHRENHEIT,
    KELVIN,
    JOULE,
    COULOMB,
    NIT,
    LUMEN,
    LUMEN_SECOND,
    LUX,
    PSI,
    NEWTON,
    FOOT,
    FOOT_PER_SEC,
    CUBIC_METER,
    RADIANT,
    STERADIANT,
    HENRY,
    FARAD,
    MOL,
    BECQUEREL,
    GRAY,
    SIEVERT;
  }

  static public class TypeSpec implements Cloneable {
    public TypeSpec() {
      this.readingtype = com.raritan.idl.sensors.Sensor_3_0_0.ReadingType.values()[0];
      this.type = com.raritan.idl.sensors.Sensor_3_0_0.Type.values()[0];
      this.unit = com.raritan.idl.sensors.Sensor_3_0_0.Unit.values()[0];
    }

    public Object clone() {
      TypeSpec copy = new TypeSpec();

      copy.readingtype = this.readingtype;
      copy.type = this.type;
      copy.unit = this.unit;

      return copy;
    }

    public com.raritan.idl.sensors.Sensor_3_0_0.ReadingType readingtype;
    public com.raritan.idl.sensors.Sensor_3_0_0.Type type;
    public com.raritan.idl.sensors.Sensor_3_0_0.Unit unit;
  }

  public class GetTypeSpecResult {
    public com.raritan.idl.sensors.Sensor_3_0_0.TypeSpec _ret_;
  }

  GetTypeSpecResult getTypeSpec() throws Exception;

  AsyncRequest getTypeSpec(AsyncRpcResponse<GetTypeSpecResult> rsp);

  AsyncRequest getTypeSpec(AsyncRpcResponse<GetTypeSpecResult> rsp, RpcCtrl rpcCtrl);


  public class SetTypeResult {
    public int _ret_;
  }

  SetTypeResult setType(com.raritan.idl.sensors.Sensor_3_0_0.Type type, com.raritan.idl.sensors.Sensor_3_0_0.Unit unit) throws Exception;

  AsyncRequest setType(com.raritan.idl.sensors.Sensor_3_0_0.Type type, com.raritan.idl.sensors.Sensor_3_0_0.Unit unit, AsyncRpcResponse<SetTypeResult> rsp);

  AsyncRequest setType(com.raritan.idl.sensors.Sensor_3_0_0.Type type, com.raritan.idl.sensors.Sensor_3_0_0.Unit unit, AsyncRpcResponse<SetTypeResult> rsp, RpcCtrl rpcCtrl);

}
