// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from ServerMonitor.idl.

package com.raritan.idl.servermon;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface ServerMonitor_2_0_0 {
  static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor:2.0.0", null);

  public enum ServerReachability {
    WAITING,
    REACHABLE,
    UNREACHABLE,
    ERROR;
  }

  static public class ServerSettings implements Cloneable {
    public ServerSettings() {
      this.host = new String();
      this.enabled = new Boolean(false);
      this.pingInterval = new Integer(0);
      this.retryInterval = new Integer(0);
      this.activationCount = new Integer(0);
      this.failureCount = new Integer(0);
      this.resumeDelay = new Integer(0);
      this.resumeCount = new Integer(0);
    }

    public Object clone() {
      ServerSettings copy = new ServerSettings();

      copy.host = this.host;
      copy.enabled = this.enabled;
      copy.pingInterval = this.pingInterval;
      copy.retryInterval = this.retryInterval;
      copy.activationCount = this.activationCount;
      copy.failureCount = this.failureCount;
      copy.resumeDelay = this.resumeDelay;
      copy.resumeCount = this.resumeCount;

      return copy;
    }

    public String host;
    public boolean enabled;
    public int pingInterval;
    public int retryInterval;
    public int activationCount;
    public int failureCount;
    public int resumeDelay;
    public int resumeCount;
  }

  static public class ServerStatus implements Cloneable {
    public ServerStatus() {
      this.reachable = com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerReachability.values()[0];
      this.lastRequest = new java.util.Date(0);
      this.lastResponse = new java.util.Date(0);
      this.requests = new Integer(0);
      this.responses = new Integer(0);
      this.failures = new Integer(0);
      this.resumes = new Integer(0);
    }

    public Object clone() {
      ServerStatus copy = new ServerStatus();

      copy.reachable = this.reachable;
      copy.lastRequest = this.lastRequest;
      copy.lastResponse = this.lastResponse;
      copy.requests = this.requests;
      copy.responses = this.responses;
      copy.failures = this.failures;
      copy.resumes = this.resumes;

      return copy;
    }

    public com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerReachability reachable;
    public java.util.Date lastRequest;
    public java.util.Date lastResponse;
    public int requests;
    public int responses;
    public int failures;
    public int resumes;
  }

  static public class Server implements Cloneable {
    public Server() {
      this.settings = new com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings();
      this.status = new com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerStatus();
    }

    public Object clone() {
      Server copy = new Server();

      Object settingsCopy = this.settings.clone();
      copy.settings = (com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings) settingsCopy;
      Object statusCopy = this.status.clone();
      copy.status = (com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerStatus) statusCopy;

      return copy;
    }

    public com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings settings;
    public com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerStatus status;
  }

  public static final int ERR_NO_SUCH_ID = 1;

  public static final int ERR_INVALID_SETTINGS = 2;

  public static final int ERR_DUPLICATE_HOSTNAME = 3;

  public static final int ERR_MAX_SERVERS_REACHED = 4;

  public class AddServerResult {
    public int _ret_;
    public int id;
  }

  AddServerResult addServer(com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings settings) throws Exception;

  AsyncRequest addServer(com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings settings, AsyncRpcResponse<AddServerResult> rsp);

  AsyncRequest addServer(com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings settings, AsyncRpcResponse<AddServerResult> rsp, RpcCtrl rpcCtrl);


  public class ModifyServerResult {
    public int _ret_;
  }

  ModifyServerResult modifyServer(int id, com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings settings) throws Exception;

  AsyncRequest modifyServer(int id, com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings settings, AsyncRpcResponse<ModifyServerResult> rsp);

  AsyncRequest modifyServer(int id, com.raritan.idl.servermon.ServerMonitor_2_0_0.ServerSettings settings, AsyncRpcResponse<ModifyServerResult> rsp, RpcCtrl rpcCtrl);


  public class DeleteServerResult {
    public int _ret_;
  }

  DeleteServerResult deleteServer(int id) throws Exception;

  AsyncRequest deleteServer(int id, AsyncRpcResponse<DeleteServerResult> rsp);

  AsyncRequest deleteServer(int id, AsyncRpcResponse<DeleteServerResult> rsp, RpcCtrl rpcCtrl);


  public class GetServerResult {
    public int _ret_;
    public com.raritan.idl.servermon.ServerMonitor_2_0_0.Server server;
  }

  GetServerResult getServer(int id) throws Exception;

  AsyncRequest getServer(int id, AsyncRpcResponse<GetServerResult> rsp);

  AsyncRequest getServer(int id, AsyncRpcResponse<GetServerResult> rsp, RpcCtrl rpcCtrl);


  public class ListServersResult {
    public java.util.Map<Integer, com.raritan.idl.servermon.ServerMonitor_2_0_0.Server> _ret_;
  }

  ListServersResult listServers() throws Exception;

  AsyncRequest listServers(AsyncRpcResponse<ListServersResult> rsp);

  AsyncRequest listServers(AsyncRpcResponse<ListServersResult> rsp, RpcCtrl rpcCtrl);

}
