// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from ServerMonitor.idl.

package com.raritan.idl.servermon;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface ServerMonitor_2_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor:2.0.1", null);

  public enum ServerReachability {
    WAITING,
    REACHABLE,
    UNREACHABLE,
    ERROR;
  }

  public enum ServerPowerState {
    UNKNOWN,
    ON,
    OFF,
    SHUTTING_DOWN;
  }

  public enum ServerPowerControlResult {
    NO_ERROR,
    SHUTDOWN_CMD_FAILED,
    SWITCHING_OFF_FAILED,
    SWITCHING_ON_FAILED,
    POWER_CHECK_TIMEOUT;
  }

  public enum ServerPowerCheckMethod {
    TIMER,
    POWER_DROP;
  }

  static public class ServerPowerSettings implements Cloneable {
    public ServerPowerSettings() {
      this.enabled = new Boolean(false);
      this.target = null;
      this.powerCheck = com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerCheckMethod.values()[0];
      this.powerThreshold = new Double(0.0);
      this.timeout = new Integer(0);
      this.shutdownCmd = new String();
      this.username = new String();
      this.password = new String();
      this.sshPort = new Integer(0);
    }

    public Object clone() {
      ServerPowerSettings copy = new ServerPowerSettings();

      copy.enabled = this.enabled;
      copy.target = this.target;
      copy.powerCheck = this.powerCheck;
      copy.powerThreshold = this.powerThreshold;
      copy.timeout = this.timeout;
      copy.shutdownCmd = this.shutdownCmd;
      copy.username = this.username;
      copy.password = this.password;
      copy.sshPort = this.sshPort;

      return copy;
    }

    public boolean enabled;
    public Object target;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerCheckMethod powerCheck;
    public double powerThreshold;
    public int timeout;
    public String shutdownCmd;
    public String username;
    public String password;
    public int sshPort;
  }

  static public class ServerSettings implements Cloneable {
    public ServerSettings() {
      this.host = new String();
      this.enabled = new Boolean(false);
      this.pingInterval = new Integer(0);
      this.retryInterval = new Integer(0);
      this.activationCount = new Integer(0);
      this.failureCount = new Integer(0);
      this.resumeDelay = new Integer(0);
      this.resumeCount = new Integer(0);
      this.powerSettings = new com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerSettings();
    }

    public Object clone() {
      ServerSettings copy = new ServerSettings();

      copy.host = this.host;
      copy.enabled = this.enabled;
      copy.pingInterval = this.pingInterval;
      copy.retryInterval = this.retryInterval;
      copy.activationCount = this.activationCount;
      copy.failureCount = this.failureCount;
      copy.resumeDelay = this.resumeDelay;
      copy.resumeCount = this.resumeCount;
      Object powerSettingsCopy = this.powerSettings.clone();
      copy.powerSettings = (com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerSettings) powerSettingsCopy;

      return copy;
    }

    public String host;
    public boolean enabled;
    public int pingInterval;
    public int retryInterval;
    public int activationCount;
    public int failureCount;
    public int resumeDelay;
    public int resumeCount;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerSettings powerSettings;
  }

  static public class ServerStatus implements Cloneable {
    public ServerStatus() {
      this.powerState = com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerState.values()[0];
      this.lastPowerControlResult = com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerControlResult.values()[0];
      this.reachable = com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerReachability.values()[0];
      this.lastRequest = new java.util.Date(0);
      this.lastResponse = new java.util.Date(0);
      this.requests = new Integer(0);
      this.responses = new Integer(0);
      this.failures = new Integer(0);
      this.resumes = new Integer(0);
    }

    public Object clone() {
      ServerStatus copy = new ServerStatus();

      copy.powerState = this.powerState;
      copy.lastPowerControlResult = this.lastPowerControlResult;
      copy.reachable = this.reachable;
      copy.lastRequest = this.lastRequest;
      copy.lastResponse = this.lastResponse;
      copy.requests = this.requests;
      copy.responses = this.responses;
      copy.failures = this.failures;
      copy.resumes = this.resumes;

      return copy;
    }

    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerState powerState;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerControlResult lastPowerControlResult;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerReachability reachable;
    public java.util.Date lastRequest;
    public java.util.Date lastResponse;
    public int requests;
    public int responses;
    public int failures;
    public int resumes;
  }

  public class ServerPowerStateEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor_2_0_1.ServerPowerStateEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int id;
    public String host;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerState oldPowerState;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerState newPowerState;
  }

  public class ServerPowerControlInitiatedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor_2_0_1.ServerPowerControlInitiatedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int id;
    public String host;
    public boolean on;
  }

  public class ServerPowerControlCompletedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor_2_0_1.ServerPowerControlCompletedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int id;
    public String host;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerPowerControlResult result;
  }

  public class ServerReachabilityEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor_2_0_1.ServerReachabilityEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int id;
    public String host;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerReachability reachable;
  }

  public class ServerAddedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor_2_0_1.ServerAddedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int id;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings;
  }

  public class ServerSettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor_2_0_1.ServerSettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int id;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings oldSettings;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings newSettings;
  }

  public class ServerDeletedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("servermon.ServerMonitor_2_0_1.ServerDeletedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public int id;
  }

  static public class Server implements Cloneable {
    public Server() {
      this.settings = new com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings();
      this.status = new com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerStatus();
    }

    public Object clone() {
      Server copy = new Server();

      Object settingsCopy = this.settings.clone();
      copy.settings = (com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings) settingsCopy;
      Object statusCopy = this.status.clone();
      copy.status = (com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerStatus) statusCopy;

      return copy;
    }

    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerStatus status;
  }

  public static final int ERR_NO_SUCH_ID = 1;

  public static final int ERR_INVALID_SETTINGS = 2;

  public static final int ERR_DUPLICATE_HOSTNAME = 3;

  public static final int ERR_MAX_SERVERS_REACHED = 4;

  public class AddServerResult {
    public int _ret_;
    public int id;
  }

  AddServerResult addServer(com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings) throws Exception;

  AsyncRequest addServer(com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings, AsyncRpcResponse<AddServerResult> rsp);

  AsyncRequest addServer(com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings, AsyncRpcResponse<AddServerResult> rsp, RpcCtrl rpcCtrl);


  public class ModifyServerResult {
    public int _ret_;
  }

  ModifyServerResult modifyServer(int id, com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings) throws Exception;

  AsyncRequest modifyServer(int id, com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings, AsyncRpcResponse<ModifyServerResult> rsp);

  AsyncRequest modifyServer(int id, com.raritan.idl.servermon.ServerMonitor_2_0_1.ServerSettings settings, AsyncRpcResponse<ModifyServerResult> rsp, RpcCtrl rpcCtrl);


  public class DeleteServerResult {
    public int _ret_;
  }

  DeleteServerResult deleteServer(int id) throws Exception;

  AsyncRequest deleteServer(int id, AsyncRpcResponse<DeleteServerResult> rsp);

  AsyncRequest deleteServer(int id, AsyncRpcResponse<DeleteServerResult> rsp, RpcCtrl rpcCtrl);


  public class GetServerResult {
    public int _ret_;
    public com.raritan.idl.servermon.ServerMonitor_2_0_1.Server server;
  }

  GetServerResult getServer(int id) throws Exception;

  AsyncRequest getServer(int id, AsyncRpcResponse<GetServerResult> rsp);

  AsyncRequest getServer(int id, AsyncRpcResponse<GetServerResult> rsp, RpcCtrl rpcCtrl);


  public class ListServersResult {
    public java.util.Map<Integer, com.raritan.idl.servermon.ServerMonitor_2_0_1.Server> _ret_;
  }

  ListServersResult listServers() throws Exception;

  AsyncRequest listServers(AsyncRpcResponse<ListServersResult> rsp);

  AsyncRequest listServers(AsyncRpcResponse<ListServersResult> rsp, RpcCtrl rpcCtrl);


  public class PowerControlResult {
    public int _ret_;
  }

  PowerControlResult powerControl(int id, boolean on) throws Exception;

  AsyncRequest powerControl(int id, boolean on, AsyncRpcResponse<PowerControlResult> rsp);

  AsyncRequest powerControl(int id, boolean on, AsyncRpcResponse<PowerControlResult> rsp, RpcCtrl rpcCtrl);

}
