// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2020 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from testrpc.idl.

package com.raritan.json_rpc.test;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class FeatSerial_Proxy extends ObjectProxy implements com.raritan.idl.test.FeatSerial {

  public FeatSerial_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public FeatSerial_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.test.FeatSerial.typeInfo);
  }

  public static FeatSerial_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new FeatSerial_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetNumberOfPortsResult getNumberOfPorts() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getNumberOfPorts", params);
    GetNumberOfPortsResult ret = new GetNumberOfPortsResult();
    ret._ret_ = result.getInt("_ret_");
    ret.numPorts = result.getInt("numPorts");
    return ret;
  }

  @Override
  public AsyncRequest getNumberOfPorts(final AsyncRpcResponse<GetNumberOfPortsResult> rsp) {
    return getNumberOfPorts(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getNumberOfPorts(final AsyncRpcResponse<GetNumberOfPortsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getNumberOfPorts", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetNumberOfPortsResult ret = new GetNumberOfPortsResult();
          ret._ret_ = result.getInt("_ret_");
          ret.numPorts = result.getInt("numPorts");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetPowerResult setPower(final int portNum, final boolean hasPower) throws Exception {
    JSONObject params = new JSONObject();
    params.put("portNum", portNum);
    params.put("hasPower", hasPower);
    final JSONObject result = rpcCall("setPower", params);
    SetPowerResult ret = new SetPowerResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setPower(final int portNum, final boolean hasPower, final AsyncRpcResponse<SetPowerResult> rsp) {
    return setPower(portNum, hasPower, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setPower(final int portNum, final boolean hasPower, final AsyncRpcResponse<SetPowerResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("portNum", portNum);
      params.put("hasPower", hasPower);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setPower", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetPowerResult ret = new SetPowerResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public TestLoopTxRxResult testLoopTxRx(final int portNum) throws Exception {
    JSONObject params = new JSONObject();
    params.put("portNum", portNum);
    final JSONObject result = rpcCall("testLoopTxRx", params);
    TestLoopTxRxResult ret = new TestLoopTxRxResult();
    ret._ret_ = result.getInt("_ret_");
    ret.errstr = result.getString("errstr");
    return ret;
  }

  @Override
  public AsyncRequest testLoopTxRx(final int portNum, final AsyncRpcResponse<TestLoopTxRxResult> rsp) {
    return testLoopTxRx(portNum, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest testLoopTxRx(final int portNum, final AsyncRpcResponse<TestLoopTxRxResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("portNum", portNum);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("testLoopTxRx", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          TestLoopTxRxResult ret = new TestLoopTxRxResult();
          ret._ret_ = result.getInt("_ret_");
          ret.errstr = result.getString("errstr");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public TestLoopDtrDcdResult testLoopDtrDcd(final int portNum) throws Exception {
    JSONObject params = new JSONObject();
    params.put("portNum", portNum);
    final JSONObject result = rpcCall("testLoopDtrDcd", params);
    TestLoopDtrDcdResult ret = new TestLoopDtrDcdResult();
    ret._ret_ = result.getInt("_ret_");
    ret.errstr = result.getString("errstr");
    return ret;
  }

  @Override
  public AsyncRequest testLoopDtrDcd(final int portNum, final AsyncRpcResponse<TestLoopDtrDcdResult> rsp) {
    return testLoopDtrDcd(portNum, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest testLoopDtrDcd(final int portNum, final AsyncRpcResponse<TestLoopDtrDcdResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("portNum", portNum);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("testLoopDtrDcd", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          TestLoopDtrDcdResult ret = new TestLoopDtrDcdResult();
          ret._ret_ = result.getInt("_ret_");
          ret.errstr = result.getString("errstr");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
